<script setup>
import { computed, watch, ref } from "vue";
import { useStore } from "vuex";
import { Handle, Position, useVueFlow } from "@vue-flow/core";
import RunSVG from "@/assets/run.svg";
import ListenSVG from "@/assets/listen.svg";
import StateNodeHeader from "@components/Level/StateNodeHeader.vue";
import ActionNode from "@/components/Level/ActionNode.vue";

const props = defineProps({
  stateName: { type: String, required: true },
  // type: { type: String, required: true },
  selected: { type: Boolean, required: true },
  // dragging: { type: Boolean, required: true },
  // connectable: { type: Boolean, required: true },
  // position: { type: Object, required: true },
  // zIndex: { type: Number, required: true },
  // dimensions: { type: Object, required: true },
  data: { type: Object, required: true },
  // events: { type: Object, required: false },
  // label: { type: String, required: false },
  // isValidTargetPos: { type: Function, required: false },
  // isValidSourcePos: { type: Function, required: false },
  // parent: { type: String, required: false }
  // targetPosition: { type: Object, required: false },
  // sourcePosition: { type: Object, required: false },
  // dragHandle: { type: String, required: false }
});

const store = useStore();
const flow = useVueFlow();
const dragOverState = ref(0);
const node = computed(() => flow.findNode(props.stateName));
const level = computed(() => store.state.level.data);
const state = computed(() => level.value.states[props.data.id]);
const isLive = computed(() => store.state.live.isLive);
const sessionSelected = computed(() => store.state.live.session != "");
const isBusy = computed(() => store.state.level.busyStates?.[props.data.id]);
const isCurrent = computed(() =>
  store.getters["live/currentLiveStates"](store.state.live.session).includes(props.data.id),
);

function onDrop(event) {
  dragOverState.value = 0;
  if (isBusy.value) return;
  const actionName = event.dataTransfer?.getData("action");
  const actionId = event.dataTransfer?.getData("actionId");
  const originState = event.dataTransfer?.getData("originState");
  if (actionName) store.dispatch("level/addAction", { stateId: props.data.id, actionName });
  if (actionId) store.dispatch("level/moveExistingAction", { stateId: props.data.id, originState, actionId });
}

watch([isBusy, isLive], () => {
  node.value.selectable = isBusy.value == undefined || isLive.value;
  node.value.draggable = isBusy.value == undefined;
});
watch([() => store.state.level.selectedState], (selectedStateId) => {
  node.value.selected = props.data.id == selectedStateId;
});
</script>

<template>
  <div
    class="state-container"
    :class="{
      'is-selected': selected,
      'is-busy': isBusy && !isLive,
      'is-current': isCurrent && isLive,
      'has-background-adaptor': dragOverState > 0,
    }"
    @dragenter.prevent.stop="dragOverState++"
    @dragend.stop="dragOverState--"
    @dragleave.prevent.stop="dragOverState--"
    @dragover.prevent.stop
    @drop.stop="onDrop"
  >
    <Handle :id="stateName" :position="Position.Left" type="target" :connectable="false" />
    <Handle :id="stateName" :position="Position.Right" type="source" :connectable="false" hidden />
    <StateNodeHeader
      :class="{ 'py-2': !state.run.length && !state.listen.length }"
      :state-id="props.data.id"
      :state="state"
      :is-live="isLive"
      :is-selected="selected"
      :session-selected="sessionSelected"
      :is-busy="isBusy"
    />
    <hr
      v-if="state.run.length"
      class="state-hr"
      :class="[isCurrent ? 'has-background-is-live' : 'has-background-black']"
    />
    <div v-if="state.run.length" class="p-1 pr-2 is-relative">
      <img
        :src="RunSVG"
        alt="Run Action Icon"
        class="is-absolute-vcenter"
        title="This section contains Run Actions. They are always executed straight away."
      />
      <ActionNode
        v-for="(actionId, index) in state.run"
        :key="actionId"
        :index="index"
        :is-first="index == 0"
        :is-last="state.run.length - 1 == index"
        :action-id="actionId"
        :state-id="props.data.id"
        :state-name="stateName"
        :state-selected="selected"
      />
    </div>

    <hr
      v-if="state.listen.length"
      class="state-hr"
      :class="[isCurrent ? 'has-background-is-live' : 'has-background-black']"
    />
    <div v-if="state.listen.length" class="p-1 is-relative">
      <img
        :src="ListenSVG"
        alt="Listen Icon"
        class="is-absolute-vcenter"
        title="This section contains Listen Actions. They wait for specific events."
      />
      <ActionNode
        v-for="(actionId, index) in state.listen"
        :key="actionId"
        :index="index"
        :is-first="index == 0"
        :is-last="state.run.length - 1 == index"
        :action-id="actionId"
        :state-id="props.data.id"
        :state-name="stateName"
        :state-selected="selected"
      />
    </div>
  </div>
</template>
